from typing import Optional

from sqlmodel import SQLModel, Field


class EmojiAccountLink(SQLModel, table=True):
    emoji_id: Optional[int] = Field(
        default=None, foreign_key='customemoji.id', primary_key=True
    )
    account_id: Optional[int] = Field(
        default=None, foreign_key='account.id', primary_key=True
    )

class EmojiStatusLink(SQLModel, table=True):
    emoji_id: Optional[int] = Field(
        default=None, foreign_key='customemoji.id', primary_key=True
    )
    status_id: Optional[int] = Field(
        default=None, foreign_key='status.id', primary_key=True
    )

class TagStatusLink(SQLModel, table=True):
    tag_id: Optional[int] = Field(
        default=None, foreign_key='tag.id', primary_key=True
    )
    status_id: Optional[int] = Field(
        default=None, foreign_key='status.id', primary_key=True
    )